>From b42ca17fe46b4cfb3d54c07b859ae2f042876c1d Mon Sep 17 00:00:00 2001
From: Arnaud <arnaud.champion@devatom.fr>
Date: Wed, 8 Dec 2010 00:48:44 +0100
Subject: [PATCH] Some naming correction in samples

---
 .../virConnectSetErrorFunc/gtk-gui/MainWindow.cs   |    1 -
 .../virDomainStats/gtk-gui/MainWindow.cs           |    1 -
 .../virDomainStats/virDomainStats.csproj           |   65 +++++++++++++++++++-
 examples/VisualStudio/virDomainStats/Form1.cs      |    1 -
 4 files changed, 64 insertions(+), 4 deletions(-)
 rewrite examples/MonoDevelop/virDomainStats/virDomainStats.csproj (100%)

diff --git a/examples/MonoDevelop/virConnectSetErrorFunc/gtk-gui/MainWindow.cs b/examples/MonoDevelop/virConnectSetErrorFunc/gtk-gui/MainWindow.cs
index 74d5abe..2e93ea7 100644
--- a/examples/MonoDevelop/virConnectSetErrorFunc/gtk-gui/MainWindow.cs
+++ b/examples/MonoDevelop/virConnectSetErrorFunc/gtk-gui/MainWindow.cs
@@ -105,7 +105,6 @@ public partial class MainWindow
 		this.GtkAlignment.LeftPadding = ((uint)(12));
 		// Container child GtkAlignment.Gtk.Container+ContainerChild
 		this.table2 = new global::Gtk.Table (((uint)(5)), ((uint)(2)), false);
-		this.table2.Name = "table2";
 		this.table2.RowSpacing = ((uint)(6));
 		this.table2.ColumnSpacing = ((uint)(6));
 		// Container child table2.Gtk.Table+TableChild
diff --git a/examples/MonoDevelop/virDomainStats/gtk-gui/MainWindow.cs b/examples/MonoDevelop/virDomainStats/gtk-gui/MainWindow.cs
index f7264d6..55d5dc3 100644
--- a/examples/MonoDevelop/virDomainStats/gtk-gui/MainWindow.cs
+++ b/examples/MonoDevelop/virDomainStats/gtk-gui/MainWindow.cs
@@ -178,7 +178,6 @@ public partial class MainWindow
 		this.GtkAlignment.LeftPadding = ((uint)(12));
 		// Container child GtkAlignment.Gtk.Container+ContainerChild
 		this.table2 = new global::Gtk.Table (((uint)(5)), ((uint)(2)), false);
-		this.table2.Name = "table2";
 		this.table2.RowSpacing = ((uint)(6));
 		this.table2.ColumnSpacing = ((uint)(6));
 		// Container child table2.Gtk.Table+TableChild
diff --git a/examples/MonoDevelop/virDomainStats/virDomainStats.csproj b/examples/MonoDevelop/virDomainStats/virDomainStats.csproj
dissimilarity index 100%
index 355d8ef..ba85627 100644
--- a/examples/MonoDevelop/virDomainStats/virDomainStats.csproj
+++ b/examples/MonoDevelop/virDomainStats/virDomainStats.csproj
@@ -1 +1,64 @@
-<?xml version="1.0" encoding="utf-8"?>
<Project DefaultTargets="Build" ToolsVersion="3.5" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
  <PropertyGroup>
    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
    <ProductVersion>9.0.21022</ProductVersion>
    <SchemaVersion>2.0</SchemaVersion>
    <ProjectGuid>{767373FC-96BE-420A-8219-97146D33B2CB}</ProjectGuid>
    <OutputType>WinExe</OutputType>
    <RootNamespace>virDomainStats</RootNamespace>
    <AssemblyName>virDomainStats</AssemblyName>
    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
  </PropertyGroup>
  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
    <DebugSymbols>true</DebugSymbols>
    <DebugType>full</DebugType>
    <Optimize>false</Optimize>
    <OutputPath>bin\Debug</OutputPath>
    <DefineConstants>DEBUG</DefineConstants>
    <ErrorReport>prompt</ErrorReport>
    <WarningLevel>4</WarningLevel>
    <ConsolePause>false</ConsolePause>
  </PropertyGroup>
  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
    <DebugType>none</DebugType>
    <Optimize>false</Optimize>
    <OutputPath>bin\Release</OutputPath>
    <ErrorReport>prompt</ErrorReport>
    <WarningLevel>4</WarningLevel>
    <ConsolePause>false</ConsolePause>
  </PropertyGroup>
  <ItemGroup>
    <Reference Include="System" />
    <Reference Include="Mono.Posix" />
    <Reference Include="gtk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
    <Reference Include="gdk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
    <Reference Include="glib-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
    <Reference Include="glade-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
    <Reference Include="pango-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
    <Reference Include="atk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
    <Reference Include="System.Xml" />
    <Reference Include="System.Core">
    </Reference>
  </ItemGroup>
  <ItemGroup>
    <EmbeddedResource Include="gtk-gui\gui.stetic">
      <LogicalName>gui.stetic</LogicalName>
    </EmbeddedResource>
  </ItemGroup>
  <ItemGroup>
    <Compile Include="gtk-gui\generated.cs" />
    <Compile Include="MainWindow.cs" />
    <Compile Include="gtk-gui\MainWindow.cs" />
    <Compile Include="Main.cs" />
    <Compile Include="AssemblyInfo.cs" />
  </ItemGroup>
  <ItemGroup>
    <ProjectReference Include="..\..\..\projects\MonoDevelop\LibvirtBindings.csproj">
      <Project>{C51C70EB-9040-4F8E-9A18-DF2A77D04A37}</Project>
      <Name>LibvirtBindings</Name>
    </ProjectReference>
  </ItemGroup>
  <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
</Project>\ No newline at end of file
+<?xml version="1.0" encoding="utf-8"?>
+<Project DefaultTargets="Build" ToolsVersion="3.5" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.21022</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{767373FC-96BE-420A-8219-97146D33B2CB}</ProjectGuid>
+    <OutputType>WinExe</OutputType>
+    <RootNamespace>virDomainStats</RootNamespace>
+    <AssemblyName>virDomainStats</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug</OutputPath>
+    <DefineConstants>DEBUG</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <ConsolePause>false</ConsolePause>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>none</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Release</OutputPath>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <ConsolePause>false</ConsolePause>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="Mono.Posix" />
+    <Reference Include="gtk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <Reference Include="gdk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <Reference Include="glib-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <Reference Include="glade-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <Reference Include="pango-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <Reference Include="atk-sharp, Version=2.12.0.0, Culture=neutral, PublicKeyToken=35e10195dab3c99f" />
+    <Reference Include="System.Xml" />
+    <Reference Include="System.Core">
+    </Reference>
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="gtk-gui\gui.stetic">
+      <LogicalName>gui.stetic</LogicalName>
+    </EmbeddedResource>
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="gtk-gui\generated.cs" />
+    <Compile Include="MainWindow.cs" />
+    <Compile Include="gtk-gui\MainWindow.cs" />
+    <Compile Include="Main.cs" />
+    <Compile Include="AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\..\projects\MonoDevelop\LibvirtBindings.csproj">
+      <Project>{C51C70EB-9040-4F8E-9A18-DF2A77D04A37}</Project>
+      <Name>LibvirtBindings</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
+</Project>\ No newline at end of file
diff --git a/examples/VisualStudio/virDomainStats/Form1.cs b/examples/VisualStudio/virDomainStats/Form1.cs
index b4fdf48..d26ecb3 100644
--- a/examples/VisualStudio/virDomainStats/Form1.cs
+++ b/examples/VisualStudio/virDomainStats/Form1.cs
@@ -2,7 +2,6 @@
 
 using System;
 using System.Linq;
-using System.Runtime.InteropServices;
 using System.Windows.Forms;
 using System.Xml;
 using Libvirt;
-- 
1.7.2.3.msysgit.0